/*  By Matt Schikore, schikore@cs.uiowa.edu  */

#include <stdio.h>
#include <io.h>
#include <ctype.h>
#include <string.h>

struct scenario {
	char listname [20];
	char subdir1 [8];
	char listdesc [30];
	int dummy1;
	char subdir2 [8];
	char subdir3 [8];
	int cities;
	int ruins;
	int players;
	int dummy3;
};

int cmpfnc(const void *a, const void *b) {
	struct scenario *s1, *s2;
	s1 = (struct scenario *)a;
	s2 = (struct scenario *)b;

	return strcmpi(s1->listname, s2->listname);
}

void main(void) {
	FILE *scenfile;
	char filename[256];
	int numscenarios, n;
	struct scenario *the_scenarios;

	strcpy(filename, "data\\scenario.dat");
	scenfile = fopen(filename, "rb");
	if (scenfile == NULL) {
		strcpy(filename, "warlords\\data\\scenario.dat");
		scenfile = fopen(filename, "rb");
		if (scenfile == NULL) {
			strcpy(filename, "\\warlords\\data\\scenario.dat");
			scenfile = fopen(filename, "rb");
			if (scenfile == NULL) {
				strcpy(filename, "\\games\\warlords\\data\\scenario.dat");
				scenfile = fopen(filename, "rb");
				if (scenfile == NULL) {
					printf("Can't find scenario.dat\nRun this in your Warlords II directory.\n");
					exit(2);
				}
			}
		}
	}
	numscenarios = filelength(fileno(scenfile))/84;
	printf("found %d scenarios\n", numscenarios);
	the_scenarios = (struct scenario *)malloc(sizeof(struct scenario)*numscenarios);
	for (n=0; n<numscenarios; n++) {
		printf("Loading scenario #%d\r", n);
		fread(&the_scenarios[n], 1, sizeof(struct scenario), scenfile);
	}
	fclose(scenfile);
	printf("Done loading... sorting...\n");
	qsort(the_scenarios, numscenarios, sizeof(struct scenario), cmpfnc);
	scenfile = fopen(filename, "wb");
	for (n=0; n<numscenarios; n++) {
		fwrite(&the_scenarios[n], 1, sizeof(struct scenario), scenfile);
	}
}


